import { addClass, removeClass } from '../../vc-util/Dom/class';
import { nextTick } from 'vue';

var listAnimation = function listAnimation(name) {
  return {
    name: name,
    appear: true,
    css: true,
    onBeforeEnter: function onBeforeEnter(node) {
      addClass(node, name);
      node.style.height = '0px';
      node.style.opacity = '0';
    },
    onEnter: function onEnter(node) {
      nextTick(function () {
        node.style.height = "".concat(node.scrollHeight, "px");
        node.style.opacity = '1';
      });
    },
    onAfterEnter: function onAfterEnter(node) {
      if (node) removeClass(node, name);
      node.style.height = undefined;
      node.style.opacity = undefined;
    },
    onBeforeLeave: function onBeforeLeave(node) {
      addClass(node, name);
      node.style.height = "".concat(node.offsetHeight, "px");
      node.style.opacity = undefined;
    },
    onLeave: function onLeave(node) {
      setTimeout(function () {
        node.style.height = '0px';
        node.style.opacity = '0';
      });
    },
    onAfterLeave: function onAfterLeave(node) {
      if (node) removeClass(node, name);
      node.style.height = undefined;
      node.style.opacity = undefined;
    }
  };
};

export default listAnimation;