"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _class = require("../../vc-util/Dom/class");

var _vue = require("vue");

var listAnimation = function listAnimation(name) {
  return {
    name: name,
    appear: true,
    css: true,
    onBeforeEnter: function onBeforeEnter(node) {
      (0, _class.addClass)(node, name);
      node.style.height = '0px';
      node.style.opacity = '0';
    },
    onEnter: function onEnter(node) {
      (0, _vue.nextTick)(function () {
        node.style.height = "".concat(node.scrollHeight, "px");
        node.style.opacity = '1';
      });
    },
    onAfterEnter: function onAfterEnter(node) {
      if (node) (0, _class.removeClass)(node, name);
      node.style.height = undefined;
      node.style.opacity = undefined;
    },
    onBeforeLeave: function onBeforeLeave(node) {
      (0, _class.addClass)(node, name);
      node.style.height = "".concat(node.offsetHeight, "px");
      node.style.opacity = undefined;
    },
    onLeave: function onLeave(node) {
      setTimeout(function () {
        node.style.height = '0px';
        node.style.opacity = '0';
      });
    },
    onAfterLeave: function onAfterLeave(node) {
      if (node) (0, _class.removeClass)(node, name);
      node.style.height = undefined;
      node.style.opacity = undefined;
    }
  };
};

var _default = listAnimation;
exports.default = _default;